SystemOrganization addCategory: #'MC2-SqueakPlatform'!

MDObject subclass: #MDAuthorInfo
	instanceVariableNames: ''
	classVariableNames: 'MDAuthor MDLastImageName'
	poolDictionaries: ''
	category: 'MC2-SqueakPlatform'!

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 12/28/2007 21:23'!
initialize
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 12/28/2007 21:09'!
prompt
	^ ' Please enter you name and email address for Monticello2 '! !

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 10/2/2008 20:10'!
shutDown
	MDLastImageName := SmalltalkImage current imageName! !

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 10/2/2008 20:10'!
startUp
	MDLastImageName = SmalltalkImage current imageName ifFalse: [ MDAuthor := nil ]! !

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 11/29/2009 09:48'!
value
	^ MDAuthor ifNil: 
		[ MDAuthor := MDTextRequest
			prompt: self prompt
			template: '' ]! !

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 10/2/2008 20:09'!
value: aString 
	"Set the name and email address of the user of the system."
	MDAuthor := aString! !

MDObject subclass: #MDPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakPlatform'!

MDPlatform class
	instanceVariableNames: 'current'!

MDPlatform class
	instanceVariableNames: 'current'!

!MDPlatform class methodsFor: 'as yet unclassified' stamp: 'cwp 5/10/2008 18:51'!
current
	^ current ifNil: [current := self new]! !

!MDPlatform class methodsFor: 'as yet unclassified' stamp: 'cwp 5/10/2008 18:51'!
current: aPlatform
	current := aPlatform! !

!MDPlatform methodsFor: 'testing' stamp: 'cwp 6/23/2008 08:56'!
aboriginalAbc
	"A wide string containing the first 3 Canadian Aboriginal Syllabics, with unicode
	values U+1401, U+1402, U+1403. Each character is encoded as 4 bytes in the array literal"
	
	^ WideString fromByteArray: #(63 192 20 1 63 192 20 2 63 192 20 3)! !

!MDPlatform methodsFor: 'image' stamp: 'cwp 10/20/2008 21:26'!
imageName
	^ SmalltalkImage current imageName! !

!MDPlatform methodsFor: 'image' stamp: 'cwp 11/17/2007 01:25'!
initials
	^ Utilities authorInitials ! !

!MDPlatform methodsFor: 'user interface' stamp: 'cwp 11/29/2009 10:45'!
prompt: prompt template: template
	^ UIManager default request: prompt initialAnswer: template! !

!MDPlatform methodsFor: 'cursor' stamp: 'cwp 5/3/2008 01:19'!
showCursor: aSymbol
	| cursor |
	cursor := aSymbol ifNotNil: [Cursor perform: aSymbol].
	ActiveHand showTemporaryCursor: cursor.
	World doOneCycleNow! !

!MDPlatform methodsFor: 'constructing' stamp: 'cwp 12/22/2006 22:25'!
systemEditor
	^ Smalltalk! !

!MDPlatform methodsFor: 'time' stamp: 'cwp 5/10/2008 18:40'!
timestampSeconds
	^ Time primSecondsClock - 2498169600! !

!MDPlatform methodsFor: 'image' stamp: 'cwp 12/28/2007 21:25'!
updateMemoProperties: properties
	properties 
		initials: Utilities authorInitials;
		author: MDAuthorInfo value! !

!MDPlatform methodsFor: 'testing' stamp: 'cwp 3/2/2008 12:19'!
variablePointersObject
	^ (ActionSequence new: 2)
		at: 1 put: #a;
		at: 2 put: #b;
		yourself! !

!MDPlatform methodsFor: 'testing' stamp: 'cwp 6/23/2008 08:42'!
wideString
	^ WideString fromString: 'abc'! !

!MDPlatform methodsFor: 'cursor' stamp: 'cwp 12/22/2007 22:27'!
withCursor: aSymbol do: aBlock
	self showCursor: aSymbol.
	^ aBlock ensure: [self showCursor: nil]! !

MDObject subclass: #MDVolatileValue
	instanceVariableNames: 'lastImageName value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakPlatform'!

!MDVolatileValue methodsFor: 'accessing' stamp: 'cwp 10/20/2008 21:26'!
value
	^ lastImageName = MDPlatform current imageName
		ifTrue: [value]
		ifFalse: [nil]! !

!MDVolatileValue methodsFor: 'accessing' stamp: 'cwp 10/21/2008 07:41'!
value: anObject 
	lastImageName := MDPlatform current imageName.
	^ value := anObject! !
MDAuthorInfo initialize!
